<?php
/*
System extentions ASJ Payment
Version: 1.1.6
Author: ASJ Inc.
*/

class WCEX_ASJ_PAYMENT {
	private $error_mes, $pay_method;
	public static $opts;
	public $reg_chart_check;
	public function __construct(){

		self::initialize_data();
		$this->pay_method = array(
			'acting_asj_card',
			'acting_asj_conv',
			'acting_asj_atodene',
			'acting_asj_atobarai',
		);
		if( is_admin() ){

			add_action( 'usces_action_admin_system_extentions', array( $this, 'setting_form') );
			add_action( 'init', array( $this, 'save_data') );
			add_filter( 'usces_filter_cod_label', array( $this, 'change_adm_fee_label'), 5);

		}else{
			$this->reg_chart_check = false;
			if( self::$opts['activate_flag'] ){

				add_filter( 'usces_filter_confirm_inform', array( $this, 'confirm_inform'), 10, 5 );
				add_filter( 'usces_filter_set_cart_fees_cod', array( $this, 'add_fee'), 5 , 2);
				add_filter( 'usces_filter_cod_label', array( $this, 'change_fee_label'), 5);
				add_filter( 'usces_filter_send_order_mail_meisai', array( $this, 'change_fee_mail'), 5);
				add_filter( 'usces_fiter_the_payment_method', array( $this, 'payment_limit'), 5);
				add_filter( 'usces_purchase_check', array( $this, 'purchase'), 5 );
				add_filter( 'usces_main', array( $this, 'change_param_asj'), 5);
				add_filter( 'usces_filter_check_acting_return_results', array( $this, 'acting_return') );
				add_filter( 'usces_filter_completion_settlement_message', array( $this, 'completion_settlement_message'), 10, 2 );
				add_action( 'usces_post_reg_orderdata', array( $this, 'order_status_change'), 10, 2 );
				add_filter( 'usces_filter_get_error_settlement', array( $this, 'error_message'), 10, 2 );
				add_filter( 'usces_filter_point_check', array( $this, 'asj_point_check'), 10);
				/* 定期購入 */
				add_action( 'usces_after_main', array( $this, 'asj_check_cart_regular'), 10);
				add_filter( 'usces_filter_cart_check', array( $this, 'asj_filter_check_cart_regular'), 10, 2);

				$this->noreceipt_status();
			}
		}
	}

	/**********************************************
	* Initialize
	***********************************************/
	public function initialize_data(){
		global $usces;
		$options = get_option('usces');

		$options['acting_settings']['asj']['payment_id'] = isset($options['acting_settings']['asj']['payment_id']) ? $options['acting_settings']['asj']['payment_id'] : '';
		$options['acting_settings']['asj']['login_id'] = isset($options['acting_settings']['asj']['login_id']) ? $options['acting_settings']['asj']['login_id'] : '';
		$options['acting_settings']['asj']['login_pass'] = isset($options['acting_settings']['asj']['login_pass']) ? $options['acting_settings']['asj']['login_pass'] : '';
		$options['acting_settings']['asj']['payment_url'] = isset($options['acting_settings']['asj']['payment_url']) ? $options['acting_settings']['asj']['payment_url'] : '';
		$options['acting_settings']['asj']['csv_url'] = isset($options['acting_settings']['asj']['csv_url']) ? $options['acting_settings']['asj']['csv_url'] : '';
		$options['acting_settings']['asj']['change_url'] = isset($options['acting_settings']['asj']['change_url']) ? $options['acting_settings']['asj']['change_url'] : '';
		$options['acting_settings']['asj']['sync_url'] = isset($options['acting_settings']['asj']['sync_url']) ? $options['acting_settings']['asj']['sync_url'] : '';
		$options['acting_settings']['asj']['card_activate'] = isset($options['acting_settings']['asj']['card_activate']) ? (int)$options['acting_settings']['asj']['card_activate'] : 0;
		$options['acting_settings']['asj']['conv_activate'] = isset($options['acting_settings']['asj']['conv_activate']) ? (int)$options['acting_settings']['asj']['conv_activate'] : 0;
		$options['acting_settings']['asj']['atodene_activate'] = isset($options['acting_settings']['asj']['atodene_activate']) ? (int)$options['acting_settings']['asj']['atodene_activate'] : 0;
		$options['acting_settings']['asj']['atobarai_activate'] = isset($options['acting_settings']['asj']['atobarai_activate']) ? (int)$options['acting_settings']['asj']['atobarai_activate'] : 0;
		$options['acting_settings']['asj']['activate_flag'] = ($options['acting_settings']['asj']['card_activate'] || $options['acting_settings']['asj']['conv_activate'] || $options['acting_settings']['asj']['atodene_activate']) ? 1 : 0;
		$options['acting_settings']['asj']['conv_fee'] = isset($options['acting_settings']['asj']['conv_fee']) ? $options['acting_settings']['asj']['conv_fee'] : 0;
		$options['acting_settings']['asj']['atodene_fee'] = isset($options['acting_settings']['asj']['atodene_fee']) ? $options['acting_settings']['asj']['atodene_fee'] : 0;
		$options['acting_settings']['asj']['atobarai_fee'] = isset($options['acting_settings']['asj']['atobarai_fee']) ? $options['acting_settings']['asj']['atobarai_fee'] : 0;
		
		$options['acting_settings']['asj']['card_retention'] = isset($options['acting_settings']['asj']['card_retention']) ? (int)$options['acting_settings']['asj']['card_retention'] : 0;
		$options['acting_settings']['asj']['card_retention_pass'] = isset($options['acting_settings']['asj']['card_retention_pass']) ? $options['acting_settings']['asj']['card_retention_pass'] : '';

		update_option( 'usces', $options );
		self::$opts = $options['acting_settings']['asj'];
	}

	/**********************************************
	* save option data
	***********************************************/
	public function save_data(){
		global $usces;
		$this->error_mes = '';
		if(isset($_POST['usces_asj_option_update'])) {
			check_admin_referer( 'admin_system', 'wc_nonce' );

			$usces->stripslashes_deep_post($_POST);
			self::$opts['payment_id'] = isset($_POST['payment_id']) ? $_POST['payment_id'] : '';
			self::$opts['login_id'] = isset($_POST['login_id']) ? $_POST['login_id'] : '';
			self::$opts['login_pass'] = isset($_POST['login_pass']) ? $_POST['login_pass'] : '';
			self::$opts['payment_url'] = isset($_POST['payment_url']) ? $_POST['payment_url'] : '';
			self::$opts['csv_url'] = isset($_POST['csv_url']) ? $_POST['csv_url'] : '';
			self::$opts['change_url'] = isset($_POST['change_url']) ? $_POST['change_url'] : '';
			self::$opts['sync_url'] = isset($_POST['sync_url']) ? $_POST['sync_url'] : '';
			self::$opts['card_activate'] = isset($_POST['card_activate']) ? (int)$_POST['card_activate'] : 0;
			self::$opts['conv_activate'] = isset($_POST['conv_activate']) ? (int)$_POST['conv_activate'] : 0;
			self::$opts['atodene_activate'] = isset($_POST['atodene_activate']) ? (int)$_POST['atodene_activate'] : 0;
			self::$opts['atobarai_activate'] = isset($_POST['atobarai_activate']) ? (int)$_POST['atobarai_activate'] : 0;
			self::$opts['activate_flag'] = (self::$opts['card_activate'] || self::$opts['conv_activate'] || self::$opts['atodene_activate'] || self::$opts['atobarai_activate']) ? 1 : 0;
			self::$opts['conv_fee'] = isset($_POST['conv_fee']) ? (int)$_POST['conv_fee'] : 0;
			self::$opts['atodene_fee'] = isset($_POST['atodene_fee']) ? (int)$_POST['atodene_fee'] : 0;
			self::$opts['atobarai_fee'] = isset($_POST['atobarai_fee']) ? (int)$_POST['atobarai_fee'] : 0;

			self::$opts['card_retention'] = isset($_POST['card_retention']) ? (int)$_POST['card_retention'] : 0;
			self::$opts['card_retention_pass'] = isset($_POST['card_retention_pass']) ? $_POST['card_retention_pass'] : '';

			if( WCUtils::is_blank($_POST['payment_id']) )
				$this->error_mes .= '※契約者番号を入力して下さい<br />';
			if( WCUtils::is_blank($_POST['login_id']) )
				$this->error_mes .= '※ログインIDを入力して下さい<br />';
			if( WCUtils::is_blank($_POST['login_pass']) )
				$this->error_mes .= '※パスワードを入力して下さい<br />';
			if( WCUtils::is_blank($_POST['payment_url']) )
				$this->error_mes .= '※決済URLを入力して下さい<br />';
			if( $_POST['card_retention'] == 1) {
				if( WCUtils::is_blank($_POST['card_retention_pass']) ) {
					$this->error_mes .= '※決済情報保持キー作成用パスワードを入力して下さい<br />';
				}
			}
			if( WCUtils::is_blank($this->error_mes) ){
				$usces->action_status = 'success';
				$usces->action_message = __('options are updated','usces');
				$options['acting_settings']['asj']['activate'] = 'on';
				if( self::$opts['card_activate'] == 1 ){
					$usces->payment_structure['acting_asj_card'] = 'クレジットカード決済（ASJペイメント）';
				}else{
					unset($usces->payment_structure['acting_asj_card']);
				}
				if( self::$opts['conv_activate'] == 1 ){
					$usces->payment_structure['acting_asj_conv'] = 'コンビニ・銀行振込決済（ASJペイメント）';
				}else{
					unset($usces->payment_structure['acting_asj_conv']);
				}
				if( self::$opts['atodene_activate'] == 1 ){
					$usces->payment_structure['acting_asj_atodene'] = '後払い決済 旧（ASJペイメント）';
				}else{
					unset($usces->payment_structure['acting_asj_atodene']);
				}
				if( self::$opts['atobarai_activate'] == 1 ){
					$usces->payment_structure['acting_asj_atobarai'] = '後払い決済（ASJペイメント）';
				}else{
					unset($usces->payment_structure['acting_asj_atobarai']);
				}
			}else{
				$usces->action_status = 'error';
				$usces->action_message = __('Data have deficiency.','usces');
				$options['acting_settings']['asj']['activate'] = 'off';
				unset($usces->payment_structure['acting_asj_card']);
				unset($usces->payment_structure['acting_asj_conv']);
				unset($usces->payment_structure['acting_asj_atodene']);
				unset($usces->payment_structure['acting_asj_atobarai']);
			}
			ksort($usces->payment_structure);

			$options = get_option('usces');
			$options['acting_settings']['asj'] = self::$opts;
			update_option('usces', $options);
			update_option('usces_payment_structure', $usces->payment_structure);
		}
	}
	/**********************************************
	* setting_form
	* Modified:27 Oct.2015
	***********************************************/
	public function setting_form(){
		$status = (self::$opts['card_activate'] || self::$opts['conv_activate'] || self::$opts['atodene_activate'] || self::$opts['atobarai_activate']) ? '<span class="running">' . __('Running', 'usces') . '</span>' : '<span class="stopped">' . __('Stopped', 'usces') . '</span>';
?>
	<form action="" method="post" name="asj_form" id="asj_form">
	<div class="postbox">
		<h3 class="hndle" id="asjpayment"><span><?php _e('ASJペイメント','usces'); ?></span><?php echo $status; ?></h3>
		<div class="inside">
		<?php if( '' != $this->error_mes ){ ?>
		<div class="error_message"><?php echo $this->error_mes; ?></div>
		<?php }else if(self::$opts['activate_flag'] === 1){ ?>
		<div class="message">十分にテストを行ってから運用してください。</div>
		<?php } ?>
		<table class="settle_table">
			<tr>
				<th>クレジットカード決済</th>
				<td><input name="card_activate" type="radio" id="card_activate_asj_1" value="1"<?php if( isset(self::$opts['card_activate']) && self::$opts['card_activate'] == 1 ) echo ' checked="checked"'; ?> /></td><td><label for="card_activate_asj_1">利用する</label></td>
				<td><input name="card_activate" type="radio" id="card_activate_asj_2" value="0"<?php if( isset(self::$opts['card_activate']) && self::$opts['card_activate'] == 0 ) echo ' checked="checked"'; ?> /></td><td><label for="card_activate_asj_2">利用しない</label></td>
				<td></td>
			</tr>
		</table>
		<table class="settle_table">
			<tr>
				<th>コンビニ・銀行振込決済</th>
				<td><input name="conv_activate" type="radio" id="conv_activate_asj_1" value="1"<?php if( isset(self::$opts['conv_activate']) && self::$opts['conv_activate'] == 1 ) echo ' checked="checked"'; ?> /></td><td><label for="conv_activate_asj_1">利用する</label></td>
				<td><input name="conv_activate" type="radio" id="conv_activate_asj_2" value="0"<?php if( isset(self::$opts['conv_activate']) && self::$opts['conv_activate'] == 0 ) echo ' checked="checked"'; ?> /></td><td><label for="conv_activate_asj_2">利用しない</label></td>
				<td></td>
			</tr>
		</table>
		<table class="settle_table">
			<tr>
				<th>後払い決済</th>
				<td><input name="atobarai_activate" type="radio" id="atobarai_activate_asj_1" value="1"<?php if( isset(self::$opts['atobarai_activate']) && self::$opts['atobarai_activate'] == 1 ) echo ' checked="checked"'; ?> /></td><td><label for="atobarai_activate_asj_1">利用する</label></td>
				<td><input name="atobarai_activate" type="radio" id="atobarai_activate_asj_2" value="0"<?php if( isset(self::$opts['atobarai_activate']) && self::$opts['atobarai_activate'] == 0 ) echo ' checked="checked"'; ?> /></td><td><label for="atobarai_activate_asj_2">利用しない</label></td>
				<td></td>
			</tr>
		</table>
		<table class="settle_table">
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_payment_id_asj');">契約者番号</a></th>
				<td colspan="6"><input name="payment_id" type="text" id="payment_id_asj" value="<?php echo esc_html(isset(self::$opts['payment_id']) ? self::$opts['payment_id'] : ''); ?>" size="20" maxlength="8" /></td>
				<td><div id="ex_payment_id_asj" class="explanation"><?php _e('「登録情報の変更 」の「契約者番号」にてご確認いただけます。（半角数字）', 'usces'); ?></div></td>
			</tr>
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_login_id_asj');">ログインID</a></th>
				<td colspan="6"><input name="login_id" type="text" id="login_id_asj" value="<?php echo esc_html(isset(self::$opts['login_id']) ? self::$opts['login_id'] : ''); ?>" size="20" maxlength="16" /></td>
				<td><div id="ex_login_id_asj" class="explanation"><?php _e('ASJペイメントへログインするためのID（半角英数）', 'usces'); ?></div></td>
			</tr>
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_login_pass_asj');">パスワード</a></th>
				<td colspan="6"><input name="login_pass" type="text" id="login_pass_asj" value="<?php echo esc_html(isset(self::$opts['login_pass']) ? self::$opts['login_pass'] : ''); ?>" size="20" maxlength="16" /></td>
				<td><div id="ex_login_pass_asj" class="explanation"><?php _e('ASJペイメントへログインするためのパスワード（半角英数）', 'usces'); ?></div></td>
			</tr>
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_payment_url_asj');">決済URL</a></th>
				<td colspan="6"><input name="payment_url" type="text" id="payment_url_asj" value="<?php echo esc_html(isset(self::$opts['payment_url']) ? self::$opts['payment_url'] : ''); ?>" size="50" maxlength="128" /></td>
				<td><div id="ex_payment_url_asj" class="explanation"><?php _e('ASJペイメントで決済を行うURL', 'usces'); ?></div></td>
			</tr>
<?php if(defined("WCEX_ASJ_PAYMENT_REGULAR") && WCEX_ASJ_PAYMENT_REGULAR::$opts['activate_flag']) { ?>
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_csv_url_asj');">定期購入CSVURL</a></th>
				<td colspan="6"><input name="csv_url" type="text" id="csv_url_asj" value="<?php echo esc_html(isset(self::$opts['csv_url']) ? self::$opts['csv_url'] : ''); ?>" size="50" maxlength="128" /></td>
				<td><div id="ex_csv_url_asj" class="explanation"><?php _e('ASJペイメントの定期購入CSVインポートURL', 'usces'); ?></div></td>
			</tr>
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_change_url_asj');">定期購入変更URL</a></th>
				<td colspan="6"><input name="change_url" type="text" id="change_url_asj" value="<?php echo esc_html(isset(self::$opts['change_url']) ? self::$opts['change_url'] : ''); ?>" size="50" maxlength="128" /></td>
				<td><div id="ex_change_url_asj" class="explanation"><?php _e('ASJペイメントの定期購入伝票変更URL', 'usces'); ?></div></td>
			</tr>
<?php } ?>
<!--
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_sync_url_asj');">同期URL</a></th>
				<td colspan="6"><input name="sync_url" type="text" id="sync_url_asj" value="<?php echo esc_html(isset(self::$opts['sync_url']) ? self::$opts['sync_url'] : ''); ?>" size="50" maxlength="128" /></td>
				<td><div id="ex_sync_url_asj" class="explanation"><?php _e('管理画面からASJペイメントと同期を行うURL', 'usces'); ?></div></td>
			</tr>
-->
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_payment_conv_fee');">コンビニ・銀行振込手数料</a></th>
				<td colspan="6"><input name="conv_fee" type="text" id="payment_conv_fee" value="<?php echo esc_html(isset(self::$opts['conv_fee']) ? self::$opts['conv_fee'] : ''); ?>" size="10" maxlength="8" /></td>
				<td><div id="ex_payment_conv_fee" class="explanation"><?php _e('ASJペイメントでコンビニ・銀行振込決済利用時に請求する手数料', 'usces'); ?></div></td>
			</tr>
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_payment_atobarai_fee');">後払い手数料</a></th>
				<td colspan="6"><input name="atobarai_fee" type="text" id="payment_atobarai_fee" value="<?php echo esc_html(isset(self::$opts['atobarai_fee']) ? self::$opts['atobarai_fee'] : ''); ?>" size="10" maxlength="8" /></td>
				<td><div id="ex_payment_atobarai_fee" class="explanation"><?php _e('ASJペイメントで後払い決済利用時に請求する手数料', 'usces'); ?></div></td>
			</tr>
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_payment_card_retention');">カード決済情報を保持</a></th>
				<td colspan="2">
					<input name="card_retention" type="radio" id="card_retention_1" value="1"<?php if( isset(self::$opts['card_retention']) && self::$opts['card_retention'] == 1 ) echo ' checked="checked"'; ?> />
				</td>
				<td>
					<label for="card_retention_1">保持する</label>
				</td>
				</td>
				<td colspan="2">
					<input name="card_retention" type="radio" id="card_retention_2" value="0"<?php if( isset(self::$opts['card_retention']) && self::$opts['card_retention'] == 0 ) echo ' checked="checked"'; ?> />
				</td>
				<td>
					<label for="card_retention_2">保持しない</label>
				</td>
				<td><div id="ex_payment_card_retention" class="explanation"><?php _e('カード決済情報の保持を行う場合にチェックを入れます', 'usces'); ?></div></td>
			</tr>
			<tr>
				<th><a style="cursor:pointer;" onclick="toggleVisibility('ex_payment_card_retention_pass');">決済情報保持キー作成用パスワード</a></th>
				<td colspan="6"><input name="card_retention_pass" type="text" id="payment_card_retention_pass" value="<?php echo esc_html(isset(self::$opts['card_retention_pass']) ? self::$opts['card_retention_pass'] : ''); ?>" size="32" maxlength="32" /></td>
				<td><div id="ex_payment_card_retention_pass" class="explanation"><?php _e('カード情報を保持する場合に決済情報保持キー作成用パスワードを設定します', 'usces'); ?></div></td>
			</tr>
		</table>
		<input name="usces_asj_option_update" type="submit" class="button button-primary" value="設定を更新" />
		</div>
		<?php wp_nonce_field( 'admin_system', 'wc_nonce' ); ?>
	</div><!--uscestabs_asj-->
	</form>
<?php
	}

	/**********************************************
	* usces_filter_set_cart_fees_cod
	* @param  $cod_fee, $entries
	* @return $cod_fee
	***********************************************/
	public function add_fee($cod_fee, $entries){
		global $usces;
		$payment = $usces->getPayments($entries['order']['payment_name']);
		if($payment['settlement'] == 'acting_asj_conv') {
			$options = get_option('usces');
			return $options['acting_settings']['asj']['conv_fee'];
		} else if($payment['settlement'] == 'acting_asj_atodene') {
			$options = get_option('usces');
			return $options['acting_settings']['asj']['atodene_fee'];
		} else if($payment['settlement'] == 'acting_asj_atobarai') {
			$options = get_option('usces');
			return $options['acting_settings']['asj']['atobarai_fee'];
		}
		return $cod_fee;
	}

	/**********************************************
	* usces_filter_set_cart_fees_cod
	* @param  $cod_fee, $entries
	* @return $cod_fee
	***********************************************/
	public function change_adm_fee_label($html){
		global $usces;
		$order = $usces->get_order_data($_REQUEST['order_id']);
		$payment = $usces->getPayments($order['payment_name']);
		if($payment['settlement'] == 'acting_asj_conv' || $payment['settlement'] == 'acting_asj_atodene' || $payment['settlement'] == 'acting_asj_atobarai') {
			return '手数料';
		}
		return $html;
	}

	/**********************************************
	* usces_filter_set_cart_fees_cod
	* @param  $cod_fee, $entries
	* @return $cod_fee
	***********************************************/
	public function change_fee_label($html){
		global $usces;
		$entry = $usces->cart->get_entry();
		$payment = $usces->getPayments($entry['order']['payment_name']);
		if($payment['settlement'] == 'acting_asj_conv' || $payment['settlement'] == 'acting_asj_atodene' || $payment['settlement'] == 'acting_asj_atobarai') {
			return '手数料';
		}
		return $html;
	}

	/**********************************************
	* usces_filter_set_cart_fees_cod
	* @param  $cod_fee, $entries
	* @return $cod_fee
	***********************************************/
	public function change_fee_mail($html){
		global $usces;
		$entry = $usces->cart->get_entry();
		$payment = $usces->getPayments($entry['order']['payment_name']);
		if(($payment['settlement'] == 'acting_asj_conv' || $payment['settlement'] == 'acting_asj_atodene' || $payment['settlement'] == 'acting_asj_atobarai') && $entry['order']['cod_fee']) {
			$str = "手数料 : ".usces_crform( $entry['order']['cod_fee'], true, false, 'return' )."\r\n";
			if(!preg_match("/\r\n手数料 : /", $html)) {
				return preg_replace("/\r\n送料 : (.*?)\r\n/", "\r\n送料 : \\1\r\n".$str, $html);
			}
		}
		return $html;
	}

	/**********************************************
	* usces_filter_set_cart_fees_cod
	* @param  $cod_fee, $entries
	* @return $cod_fee
	***********************************************/
	public function payment_limit($payment){
		global $usces;
		$usces->point_check( $usces->cart->get_entry() );/*  */
		$usces_entries = $usces->cart->get_entry();
		$total = $usces_entries["order"]["total_full_price"] - $usces_entries["order"]["cod_fee"];
		foreach($payment as $key => $val){
			switch($val['settlement']) {
			case 'acting_asj_card':
				if($total > WCEX_ASJ_PAYMENT_CARD_MAX || $total < WCEX_ASJ_PAYMENT_CARD_MIN) {
					unset($payment[$key]);
				}
				break;
			case 'acting_asj_conv':
				$options = get_option('usces');
				$cod_fee = $options['acting_settings']['asj']['conv_fee'];
				if($total + $cod_fee > WCEX_ASJ_PAYMENT_CONV_MAX || $total + $cod_fee < WCEX_ASJ_PAYMENT_CONV_MIN) {
					unset($payment[$key]);
				}
				break;
			case 'acting_asj_atodene':
				$options = get_option('usces');
				$cod_fee = $options['acting_settings']['asj']['atodene_fee'];
				if($total + $cod_fee > WCEX_ASJ_PAYMENT_ATODENE_MAX || $total + $cod_fee < WCEX_ASJ_PAYMENT_ATODENE_MIN) {
					unset($payment[$key]);
				}
				break;
			case 'acting_asj_atobarai':
				$options = get_option('usces');
				$cod_fee = $options['acting_settings']['asj']['atobarai_fee'];
				if($total + $cod_fee > WCEX_ASJ_PAYMENT_ATODENE_MAX || $total + $cod_fee < WCEX_ASJ_PAYMENT_ATODENE_MIN) {
					unset($payment[$key]);
				}
				break;
			}
		}
		return $payment;
	}

	/**********************************************
	* usces_filter_noreceipt_status
	* @param  $actings
	* @return array $actings
	***********************************************/
	public function noreceipt_status(){
		$noreceipt_status = get_option( 'usces_noreceipt_status' );
		$noreceipt_status = array_diff($noreceipt_status, $this->pay_method);
		$noreceipt_status = array_values($noreceipt_status);
		$noreceipt_status = array_merge($noreceipt_status, $this->pay_method);
		update_option( 'usces_noreceipt_status', $noreceipt_status );
	}

	/**********************************************
	* usces_filter_completion_settlement_message
	* @param  $html, $usces_entries
	* @return str $html
	***********************************************/
	public function completion_settlement_message( $html, $usces_entries ){
		global $wpdb, $usces, $wp_version;

		$payments = usces_get_payments_by_name($usces_entries['order']['payment_name']);
		switch($payments['settlement']) {
		case 'acting_asj_conv':
			$title = 'コンビニ・銀行振込';
			$charge_type = 2;
			break;
//		case 'acting_asj_card':
			$title = 'クレジット';
			$charge_type = 1;
			break;
		default:
			return $html;
		}
		$acting_opts = $usces->options['acting_settings']['asj'];
		$order = $usces_entries['order'];
		$customer = $usces_entries['customer'];
		$arrSendData = array(
			'admin' => $acting_opts['payment_id'],					// 契約者番号
			'charge' => $order['ID'],						// オーダー番号
			'amount' => $order['total_full_price'],					// 決済金額
			'mail' => $customer['mailaddress1'],					// メールアドレス
			'name' => $customer['name1']."　".$customer['name2'],			// 名前
			'charge_type' => $charge_type,						// 支払方法
			'acting' => $payments['settlement'],
			'acting_return' => 1,
			'version' => USCES_VERSION .'_'. WCEX_ASJ_PAYMENT_VERSION,
		);
		$html .= "<div id=\"status_table\">\n";
//		$html .= '<h5>ASJペイメント・'.$title.'決済</h5>';
		$html .= '<p style="width:120%;"><font color="red">【注意】注文は確定していません。<br />
				「お支払い手続きをする」をクリックして手続きを行ってください。<br />
				決済方法を選択した後、払込票等が表示されますので代金をお支払いください。<br />
				なお、払込票等の画面の印刷が済みましたら、その画面を閉じてください。</font></p>';
		$html .= '<form target="_blank" action="'.$acting_opts['payment_url'].'" method="post" name="asj_form" id="asj_form" onsubmit="return false;" accept-charset="EUC-JP">';
			foreach($arrSendData as $key => $val){
					$html .= "\t\t<input type=\"hidden\" name=\"".$key."\" value=\"".$val."\">\n";
			}
		$html .= "<input type=\"button\" value=\"お支払い手続きをする\" onclick=\"document.charset='EUC-JP'; document.asj_form.submit();\"></form>\n";
		$html .= "</div>\n";
		return $html;
	}


	/**********************************************
	* Order purchase form
	* @param  $html, $payments, $acting_flag, $rand, $purchase_disabled
	* @return form str
	***********************************************/
	public function confirm_inform( $html, $payments, $acting_flag, $rand, $purchase_disabled ){
		if( in_array($acting_flag, $this->pay_method) ){
			$html = '<form id="purchase_form" action="' . USCES_CART_URL . '" method="post" onKeyDown="if (event.keyCode == 13) {return false;}">
				<div class="send">
				<input name="backDelivery" type="submit" id="back_button" value="'.__('Back', 'usces').'"'.apply_filters('usces_filter_confirm_prebutton', NULL).' />
				<input name="purchase" type="submit" id="purchase_button" class="checkout_button" value="'.__('Checkout', 'usces').'"'.$purchase_disabled.' /></div>
				<input type="hidden" name="rand" value="'.$rand.'">
				<input type="hidden" name="_nonce" value="'.wp_create_nonce( $acting_flag ).'">' . "\n";
		}
		return $html;
	}

	/**********************************************
	* Order Purchase
	* @param  no use
	* @return allways false
	***********************************************/
	public function purchase( $nouse ){
		global $usces;

		$usces_entries = $usces->cart->get_entry();
		$cart = $usces->cart->get_cart();
		if( !$usces_entries || !$cart) {
			wp_redirect(USCES_CART_URL);
		}
		/* 定期購入のカートチェック */
		if($this->asj_check_cart_regular_purchase()) {
			wp_redirect(USCES_CART_URL);
			exit;
		}
		$payments = usces_get_payments_by_name($usces_entries['order']['payment_name']);
		$acting_flag = ( 'acting' == $payments['settlement'] ) ? $payments['module'] : $payments['settlement'];
		if( !in_array($acting_flag, $this->pay_method) )
			return true;

		if( !wp_verify_nonce( $_REQUEST['_nonce'], $acting_flag ) )
			wp_redirect(USCES_CART_URL);

		if('acting_asj_card' == $acting_flag || 'acting_asj_atodene' == $acting_flag || 'acting_asj_atobarai' == $acting_flag) {
			$_REQUEST += array(
				'acting'	=>	$acting_flag,
				'no_result'	=>	1,
			);
			$result = array(
					'result' => 1,
					'acting' => $acting_flag,
					'acting_return' => 1,
					0	=>	1,
			);
			$result = apply_filters( 'usces_filter_check_acting_return_results', $result );
			$usces->order_processing($result);/* 購入処理 */
			/* 戻ってこない order_status_changeで飛ばす */
			exit;
		}
		return true;

	}

	/**********************************************
	* Acting change_param_asj
	* @param  $results
	* @return array
	***********************************************/
	public function change_param_asj(){
		if( !isset($_REQUEST['acting']) || !('acting_asj_card' == $_REQUEST['acting'] || 'acting_asj_conv' == $_REQUEST['acting'] || 'acting_asj_atodene' == $_REQUEST['acting'] || 'acting_asj_atobarai' == $_REQUEST['acting'])) {
			return;
		}
		$getpost = $_POST + $_GET;
		if(array_key_exists('asjres', $getpost)) {
			return;
		}
		/* result が逆なので逆転させ、本来の値をasjresに入れる。 */
		/* 不要なパラメータは切り飛ばす */
		$query_data = array();
		foreach($getpost as $key => $val){
			switch($key) {
			case 'result':
				/* ASJのresultと反対なので反転 */
				if($val == 0 || $val == 2) {
					$query_data[$key] = 1;
				} else {
					$query_data[$key] = 0;
				}
				$query_data['asjres'] = $val;
				break;
			case 'atodene_result':
			case 'atobarai_result':
			case 'admin':
			case 'payment':
			case 'payment_no':
			case 'name':
			case 'mail':
				break;
			default:
				$query_data[$key] = $val;
				break;
			}
		}
		/* アクセスしなおす */
		wp_redirect(add_query_arg($query_data, USCES_CART_URL));
		exit;
	}

	/**********************************************
	* error_message
	* @param  $html
	* @return form str
	***********************************************/
	public function error_message( $html ){
		if( !in_array( 'acting_'.$_REQUEST['acting'], $this->pay_method) && isset($_REQUEST['charge'])) {
			if(isset($_REQUEST['acting']) && ('acting_asj_card' == $_REQUEST['acting'] || 'acting_asj_atodene' == $_REQUEST['acting'] || 'acting_asj_atobarai' == $_REQUEST['acting'])) {
				$html .= "決済できませんでした。";
			}
		}
		return $html;
	}

	/**********************************************
	* prev_usces_delete_orderdata
	* @param  $order_id
	* @return -
	* usces_delete_orderdata 内で、在庫を戻す処理が存在するが、
	* 管理画面からの呼び出しでしか実行されないため、処理を抜き出してusces_delete_orderdataの前に実行する
	* plugins/usc-e-shop/extensions/OrderStockLinkage/order_stock_linkage.php  del_order
	***********************************************/
	public function prev_usces_delete_orderdata( $order_id ) {
		global $wpdb, $usces;

		$query = $wpdb->prepare("SELECT * FROM $order_table WHERE ID = %d", $order_id);
		$order_data = $wpdb->get_row( $query, OBJECT );
		$args = compact('ID', 'point', 'res');
		extract($args);//$ID,$point,$res
		if(!$usces->is_status('adminorder', $order_data->order_status)
		&& !$usces->is_status('estimate', $order_data->order_status)
		&& !$usces->is_status('cancel', $order_data->order_status)) {
			$carts = usces_get_ordercartdata($order_id);
			foreach($carts as $cart) {
				$zaikonum = $usces->getItemZaikoNum($cart['post_id'], $cart['sku_code']);
				if(WCUtils::is_blank($zaikonum)) {
					continue;
				}
				$stock_id = $usces->getItemZaikoStatusId($cart['post_id'], $cart['sku_code']);
				$itemOrderAcceptable = $usces->getItemOrderAcceptable($cart['post_id']);
				$value = $zaikonum + $cart['quantity'];
				if($itemOrderAcceptable != 1) {
					if(WCUtils::is_zero($zaikonum) && 2 <= $stock_id){
						usces_update_sku( $cart['post_id'], $cart['sku_code'], 'stock', 0);
					}
				}
				usces_update_sku( $cart['post_id'], $cart['sku_code'], 'stocknum', $value);
			}
		}
	}

	/**********************************************
	* 
	* @param  $results
	* @return array
	***********************************************/
	public function regular_acting_return($order_id) {
		global $wpdb;
		global $asj_payment_regular;

		if(!defined("WCEX_ASJ_PAYMENT_REGULAR") || !WCEX_ASJ_PAYMENT_REGULAR::$opts['activate_flag']) {
			return;
		}
		if(!$_REQUEST['regular_id']) {
			return;
		}
		$order_table = $wpdb->prefix . "usces_order";
		$ordercart_table = $wpdb->prefix . "usces_ordercart";

		$qstr = '';
		$qstr .= "SELECT *";
		$qstr .= " FROM $order_table T1";
		$qstr .= " WHERE T1.ID = %d";
		$query = $wpdb->prepare($qstr, $order_id);
		$order = $wpdb->get_row($query, OBJECT);

		$mem_id = 0;
		if(usces_is_login()) {
			$mem_id = usces_memberinfo('ID','return');
		}
		$qstr  = '';
		$qstr .= "SELECT *";
		$qstr .= " FROM $ordercart_table T1";
		$qstr .= " WHERE T1.order_id = %d";
		$query = $wpdb->prepare($qstr, $order_id);
		$ordercart = $wpdb->get_row($query, OBJECT);
		$regular_kind = 0;
		if($ordercart->post_id) {
			$custom_table = $wpdb->prefix . "postmeta";
			$qstr  = '';
			$qstr .= "SELECT T1.meta_value";
			$qstr .= " FROM $custom_table T1";
			$qstr .= " WHERE T1.meta_key = 'regular_kind'";
			$qstr .= " AND T1.post_id = %d";
			$query = $wpdb->prepare($qstr, $ordercart->post_id);
			$regular_kind = $wpdb->get_var($query);
		}
		if($regular_kind) {
			$datetime = strtotime($order->order_date);
			$order_d = date('d', $datetime);
			if(WCEX_ASJ_PAYMENT_REGULAR::$opts['regular_config_min_day'] > 0
			&& $order_d >= WCEX_ASJ_PAYMENT_REGULAR::$opts['regular_config_min_day']) {
				$tmp_status = WCEX_PG_ASJ_PAYMENT_REG_STATUS_MIN_SPAN;
				$min_day = WCEX_ASJ_PAYMENT_REGULAR::$opts['regular_config_min_day'];
			} else {
				$tmp_status = WCEX_PG_ASJ_PAYMENT_REG_STATUS_SALES;
				$min_day = 0;
			}
			$arr_set = array(
				'mem_id' => $mem_id,
				'post_id' => $ordercart->post_id,
				'item_name' => $ordercart->item_name,
				'item_code' => $ordercart->item_code,
				'sku_code' => $ordercart->sku_code,
				'sku_name' => $ordercart->sku_name,
				'price' => $ordercart->price,
				'quantity' => $ordercart->quantity,
				'unit' => $ordercart->unit,
				'tax' => $ordercart->tax,
				'min_day' => $min_day,
				'first_order_id' => $order_id,
				'last_order_id' => $order_id,
				'status' => $tmp_status,
				'order_payment_name' => $order->order_payment_name,
				'regular_kind' => $regular_kind,
			);
			$arr_format = array('%d', '%d', '%s', '%s', '%s', '%s', '%f', '%f', '%s', '%f', '%d', '%d', '%d', '%d', '%s', '%d');
			$wpdb->insert($asj_payment_regular->tbl_ord, $arr_set, $arr_format);
			$reg_order_id = $wpdb->insert_id;
			$arr_set = array(
				'reg_order_id' => $reg_order_id,
				'regular_id' => $_REQUEST['regular_id']
			);
			$arr_format = array('%d', '%d');
			$wpdb->insert($asj_payment_regular->tbl_ord_to_reg, $arr_set, $arr_format);
		}
	}

	/**********************************************
	* Acting return
	* @param  $results
	* @return array
	***********************************************/
	public function acting_return( $results ){
		global $wpdb, $usces;
		if(array_key_exists('preorder', $_SESSION) == true) {
			$order_id = $_SESSION['preorder'];
			unset($_SESSION['preorder']);
		}
		if(array_key_exists('preorderh', $_SESSION) == true) {
			$sess_check = $_SESSION['preorderh'];
			unset($_SESSION['preorderh']);
		}
		if( !in_array( 'acting_'.$results['acting'], $this->pay_method) && isset($_REQUEST['charge'])) {
			if('acting_asj_card' == $results['acting'] || 'acting_asj_atodene' == $results['acting'] || 'acting_asj_atobarai' == $results['acting']) {
				$order_id = $results['charge'];	/* 取り直す */
				$order_table = $wpdb->prefix . "usces_order";
				$order_status = $wpdb->get_var($wpdb->prepare("SELECT order_status FROM $order_table WHERE ID = %d", $order_id));
				if( $usces->is_status('noreceipt', $order_status)) {
					if(isset($results['result']) && $results['result'] && isset($results['asjres']) && ($results['asjres'] == 0 || $results['asjres'] == 2)) {
						if(('acting_asj_atodene' == $results['acting'] || 'acting_asj_atobarai' == $results['acting']) && $results['asjres'] == 2) {
							usces_change_order_receipt( $order_id, 'noreceipt' );
						} else {
							usces_change_order_receipt( $order_id, 'receipted' );
							usces_action_acting_getpoint( $order_id );
						}
						usces_send_ordermail( $order_id );
						$usces->cart->crear_cart();
					} else {
						$_REQUEST['order_id'] = $order_id;
						/* 伝票削除前に在庫を戻す */
						$this->prev_usces_delete_orderdata( $order_id );
						/* 伝票削除 */
						usces_delete_orderdata();
						if('acting_asj_atodene' == $results['acting'] || 'acting_asj_atobarai' == $results['acting']) {
							wp_redirect(USCES_CART_URL);
							exit;
						}
					}
				}
				if(isset($results['result']) && $results['result'] && isset($results['asjres']) && ($results['asjres'] == 0 || $results['asjres'] == 2)) {
					include USCES_PLUGIN_DIR . "/templates/cart/completion.php";
					$template = implode('', file(WCEX_ASJ_PAYMENT_DIR . "/completion.php"));
				} else {
					include USCES_PLUGIN_DIR . "/templates/cart/error.php";
					$template = implode('', file(WCEX_ASJ_PAYMENT_DIR . "/error.php"));
				}
				if('acting_asj_atodene' == $results['acting'] && $results['asjres'] == 2) {
					$html .='<br><p style="width:120%;"><font color="red">
						【注意】現在、後払い決済の利用についての審査結果を確認しております。<br>
						結果が判明しましたら、改めてご連絡いたします。<br>
						しばらくお待ちください。
						</font></p>';
				} else if('acting_asj_atobarai' == $results['acting'] && $results['asjres'] == 2) {
					$html .='<br><p style="width:120%;"><font color="red">
						【注意】現在、後払い決済の利用についての審査結果を確認しております。<br>
						結果が判明しましたら、改めてご連絡いたします。<br>
						しばらくお待ちください。
						</font></p>';
				}

				/* 定期購入 */
				global $asj_payment_regular;
				if(is_object($asj_payment_regular)) {
					$this->regular_acting_return($order_id);
				}


				get_header();
				echo str_replace('###CONTENTS###', $html, $template);
				//echo implode('', file(WCEX_ASJ_PAYMENT_DIR . "/header.php")) .$html. implode('', file(WCEX_ASJ_PAYMENT_DIR . "/footer.php"));
				get_sidebar( 'other' );
				get_footer();
				exit;
				/* 完了 */
			}
		} else if(isset($order_id) && isset($sess_check)) {
			$acting_opts = $usces->options['acting_settings']['asj'];
			$check = hash("sha256", sprintf("%010d%010d%s", $acting_opts['payment_id'], $order_id, WCEX_ASJ_PAYMENT_COOKEY_KEY));
			if($sess_check === $check) {
				$order_table = $wpdb->prefix . "usces_order";
				$order_status = $wpdb->get_var($wpdb->prepare("SELECT order_status FROM $order_table WHERE ID = %d", $order_id));
				if($usces->is_status('noreceipt', $order_status)) {
					$_REQUEST['order_id'] = $order_id;
					/* 伝票削除前に在庫を戻す */
					$this->prev_usces_delete_orderdata( $order_id );
					/* 伝票削除 */
					usces_delete_orderdata();
				}
				wp_redirect(USCES_CART_URL);
				exit;
				/* 完了 */
			}
		}
		return $results;
	}


	/**********************************************
	* usces_post_reg_orderdata
	* 初期入金状況を「未入金」に指定
	* @param  $order_id, $results
	* @return -
	***********************************************/
	public function order_status_change( $order_id, $results ){
		global $wpdb, $usces;
		if( !isset($results['acting']) || ('acting_asj_card' != $results['acting'] && 'acting_asj_atodene' != $results['acting'] && 'acting_asj_atobarai' != $results['acting'])) {
			return;
		}
		$state = array(
			'',
			'北海道',
			'青森県',
			'岩手県',
			'宮城県',
			'秋田県',
			'山形県',
			'福島県',
			'茨城県',
			'栃木県',
			'群馬県',
			'埼玉県',
			'千葉県',
			'東京都',
			'神奈川県',
			'新潟県',
			'富山県',
			'石川県',
			'福井県',
			'山梨県',
			'長野県',
			'岐阜県',
			'静岡県',
			'愛知県',
			'三重県',
			'滋賀県',
			'京都府',
			'大阪府',
			'兵庫県',
			'奈良県',
			'和歌山県',
			'鳥取県',
			'島根県',
			'岡山県',
			'広島県',
			'山口県',
			'徳島県',
			'香川県',
			'愛媛県',
			'高知県',
			'福岡県',
			'佐賀県',
			'長崎県',
			'熊本県',
			'大分県',
			'宮崎県',
			'鹿児島県',
			'沖縄県',
		);
		$acting = $results['acting'];
		usces_change_order_receipt( $order_id, 'noreceipt' );
		$acting_opts = $usces->options['acting_settings']['asj'];
		$usces_entries = $usces->cart->get_entry();
		$usces_carts = $usces->cart->get_cart();
		$customer = $usces_entries['customer'];
		$delivery = $usces_entries['delivery'];
		$amount = usces_crform($usces_entries['order']['total_full_price'], false, false, 'return', false);
		$cart_table = $wpdb->prefix . "usces_ordercart";
		if('acting_asj_card' == $acting) {
			//ログイン時で決済を保持する場合
			if(usces_is_login() && $acting_opts['card_retention'] == '1'){
				$unix_time = time();
				$var_key_param = 'admin='.$acting_opts['payment_id'].'&amount='.$amount.'&charge='.$order_id.'&user='.usces_memberinfo('ID','return').'&time='.$unix_time.'&'.mb_convert_encoding($acting_opts['card_retention_pass'], 'EUC-JP', 'auto');
				$arrSendData = array(
					'acting' => $acting,
					'acting_return' => 1,
					'admin' => $acting_opts['payment_id'],				// 契約者番号
					'amount' => $amount,						// 決済金額
					'charge' => $order_id,						// オーダー番号
					'charge_type' => 1,						// 支払方法
					'mail' => $customer['mailaddress1'],				// メールアドレス
					'name' => $customer['name1']."　".$customer['name2'],		// 名前
					'user' => usces_memberinfo('ID','return'),			// 会員番号
					'time' => $unix_time,						// 送信時刻
					'key' => hash("sha256", $var_key_param),
					'version' => USCES_VERSION .'_'. WCEX_ASJ_PAYMENT_VERSION,
				);
			} else {
				$arrSendData = array(
					'admin' => $acting_opts['payment_id'],				// 契約者番号
					'charge' => $order_id,						// オーダー番号
					'amount' => $amount,						// 決済金額
					'mail' => $customer['mailaddress1'],				// メールアドレス
					'name' => $customer['name1']."　".$customer['name2'],		// 名前
					'charge_type' => 1,						// 支払方法
					'acting' => $acting,
					'acting_return' => 1,
					'version' => USCES_VERSION .'_'. WCEX_ASJ_PAYMENT_VERSION,
				);
			}
		} else {
			$zip2 = substr($customer['zipcode'], 3);
			if(strpos($customer['zipcode'],'-')) {
				$tmp = explode("-", $customer['zipcode']);
				$zip2 = $tmp[1];
			}
			$ship_zip2 = substr($delivery['zipcode'], 3);
			if(strpos($delivery['zipcode'],'-')) {
				$tmp = explode("-", $delivery['zipcode']);
				$ship_zip2 = $tmp[1];
			}
			if('acting_asj_atodene' == $acting) {
				// アトディーネ
				$charge_type = 4;
			} else if('acting_asj_atobarai' == $acting) {
				// 後払い.com
				$charge_type = 7;
			}
			
			$arrSendData = array(
				'admin' => $acting_opts['payment_id'],				// 契約者番号
				'charge' => $order_id,						// オーダー番号
				'amount' => $amount,						// 決済金額
				'mail' => $customer['mailaddress1'],				// メールアドレス
				'name' => $customer['name1']."　".$customer['name2'],		// 名前
				'charge_type' => $charge_type,						// 支払方法

				'zip1' => substr($customer['zipcode'], 0, 3),			// 郵便番号1
				'zip2' => $zip2,									// 郵便番号2
				'state' => array_search($customer['pref'], $state),		// 都道府県
				'city' => htmlspecialchars($customer['address1'], ENT_QUOTES),	// 市区町村
				'street' => htmlspecialchars($customer['address2'].$customer['address3'], ENT_QUOTES),	// 番地以降
				'tel' => $customer['tel'],								// 電話番号

				'ship_name' => $delivery['name1']."　".$delivery['name2'],	// 配送先名前
				'ship_zip1' => substr($delivery['zipcode'], 0, 3),		// 配送先郵便番号1
				'ship_zip2' => $ship_zip2,									// 配送先郵便番号2
				'ship_state' => array_search($delivery['pref'], $state),	// 配送先都道府県
				'ship_city' => htmlspecialchars($delivery['address1'], ENT_QUOTES),		// 配送先市区町村
				'ship_street' => htmlspecialchars($delivery['address2'].$delivery['address3'], ENT_QUOTES),	// 配送先番地以降
				'ship_tel' => $delivery['tel'],		// 配送先電話番号

				'acting' => $acting,
				'acting_return' => 1,
				'version' => USCES_VERSION .'_'. WCEX_ASJ_PAYMENT_VERSION,
			);
			$i = 1;
			foreach ($usces_carts as $cart_row) {
				$arrSendData += array(
					'item'.$i => htmlspecialchars($usces->getItemName($cart_row['post_id']), ENT_QUOTES),	// 商品名
					'price'.$i => $cart_row['price'],														// 単価
					'count'.$i => $cart_row['quantity'],													// 数量
				);
				$i++;
			}
			//税別時の消費税
			if($usces_entries['order']['tax'] > 0) {
				$arrSendData += array(
					'item'.$i => "消費税",
					'price'.$i => $usces_entries['order']['tax'],
					'count'.$i => "1",
				);
				$i++;
			}
			//明細作成用にキャンペーン割引
			if($usces_entries['order']['discount'] < 0) {
				$arrSendData += array(
					'item'.$i => "キャンペーン割引",
					'price'.$i => $usces_entries['order']['discount'],
					'count'.$i => "1",
				);
				$i++;
			}
			//明細作成用に送料
			if($usces_entries['order']['shipping_charge'] > 0) {
				$arrSendData += array(
					'item'.$i => "送料",
					'price'.$i => $usces_entries['order']['shipping_charge'],
					'count'.$i => "1",
				);
				$i++;
			}
			//明細作成用に手数料
			if($usces_entries['order']['cod_fee'] > 0) {
				$arrSendData += array(
					'item'.$i => "手数料",
					'price'.$i => $usces_entries['order']['cod_fee'],
					'count'.$i => "1",
				);
				$i++;
			}
			//明細作成用に使ったポイント
			if($usces_entries['order']['usedpoint'] > 0) {
				$arrSendData += array(
					'item'.$i => "使用ポイント",
					'price'.$i => 0 - $usces_entries['order']['usedpoint'],
					'count'.$i => "1",
				);
				$i++;
			}
		}

		// 定期購入
		global $asj_payment_regular;
		if(is_object($asj_payment_regular) && count($usces_carts) == 1
		&& WCEX_ASJ_PAYMENT_REGULAR::$opts['activate_flag'] && intval(WCEX_ASJ_PAYMENT_REGULAR::$opts['activate_flag'])) {
			$regular_kind = '';
			if($usces_carts[0]['post_id']) {
				$custom_table = $wpdb->prefix . "postmeta";
				$qstr = "";
				$qstr .= "SELECT meta_value";
				$qstr .= " FROM $custom_table";
				$qstr .= " WHERE meta_key = 'regular_kind'";
				$qstr .= " AND post_id = %d";
				$regular_kind = $wpdb->get_var($wpdb->prepare($qstr, $usces_carts[0]['post_id']));
			}
			if(isset($regular_kind) && $regular_kind > 0) {
				$arrSendData = array_merge($arrSendData, array("regular" => "1"));
				$arrSendData = array_merge($arrSendData, array("regular_kind" => $regular_kind));
				$arrSendData = array_merge($arrSendData, array("min_day" => WCEX_ASJ_PAYMENT_REGULAR::$opts['regular_config_min_day']));
				$arrSendData = array_merge($arrSendData, array("regular_amount" => $amount));
				$arrSendData['version'] = USCES_VERSION .'_'. WCEX_ASJ_PAYMENT_VERSION . '_' . WCEX_ASJ_PAYMENT_REGULAR_VERSION;
			}
		}

		$html = '<HTML>
			<BODY>
			<form id="purchase_asj" name="purchase_asj" action="'.$acting_opts['payment_url'].'" method="post">';
		foreach($arrSendData as $key => $val){
			$html .= "\t\t<input type=\"hidden\" name=\"".$key."\" value=\"".mb_convert_encoding($val, 'EUC-JP', 'auto')."\">\n";
		}
		$str = '決済ページへ転送します。<br />
			転送されない場合は次へボタンで移動してください。<br />
			<input type="submit" value="次へ">';
		$html .= mb_convert_encoding($str, 'EUC-JP', 'auto').'</form>
			<script type="text/javascript">
				document.purchase_asj.submit();
			</script>
			</BODY>
			</HTML>';
		$_SESSION["preorder"] = strval($order_id);
		$_SESSION["preorderh"] = hash("sha256", sprintf("%010d%010d%s", $acting_opts['payment_id'], $order_id, WCEX_ASJ_PAYMENT_COOKEY_KEY));
		/* Chrome だったら */
		if(strpos($_SERVER['HTTP_USER_AGENT'], 'Chrome/') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'Edge/') === false) {
			/* samesite=none 対応 */
			$cookieopt = session_get_cookie_params();
			$re_cookie = true;
			if(strtolower($cookieopt['samesite']) === 'none' && $cookieopt['secure'] === true) {
				$re_cookie = false;
			}
			/* セッション */
			if($re_cookie === true && array_key_exists(session_name(), $_COOKIE)) {
				session_write_close();
				session_set_cookie_params($cookieopt["lifetime"], $cookieopt["path"]."; SameSite=None", $cookieopt["domain"], true, $cookieopt["httponly"]);
				session_start();
			}
			/* Welcart の cookieは現状関係なく差し替え */
			$usces_cookie_value = $usces->get_cookie();
			if(isset($usces_cookie_value)) {
				$usces_cookie_value = usces_serialize($usces_cookie_value);
				$timeout = time() + 7 * 86400;
				$timeout = apply_filters( 'usces_filter_set_cookie_timeout', $timeout, $usces_cookie_value, 'usces_cookie');
				$domain = $_SERVER['SERVER_NAME'];
				$php_v = phpversion();
				if(version_compare($php_v, '7.2') <= 0) {
					// php 7.2以前
					setcookie('usces_cookie', $usces_cookie_value, $timeout, USCES_COOKIEPATH."; SameSite=None", $domain, true, true);
				} else {
					// php 7.3以降
					setcookie('usces_cookie'
						, $usces_cookie_value
						, ['expires' => $timeout
						, 'path' => USCES_COOKIEPATH
						, 'samesite' => 'strict'
						, 'domain' => $domain
						, 'secure' => true
						, 'httponly' => true
						]
					);
				}
			}
		}
		header("Content-type: text/html; charset=EUC-JP");
		echo $html;
		exit;
		/* 戻らずにメールを送らない */
	}

	public function asj_point_check( $mes ){
		global $usces;
		$usces_entries = $usces->cart->get_entry();
		$options = get_option('usces');
		$usedpoint = (int)trim($_POST['offer']["usedpoint"]);
		if($usedpoint == 0) {
			return $mes;
		}
		$total = $usces_entries['order']['total_items_price'] + $usces_entries['order']['discount'] + $usces_entries['order']['shipping_charge'] + $usces_entries['order']['cod_fee'] - $usedpoint;
		$materials = array(
			'total_items_price' => $usces_entries['order']['total_items_price'],
			'discount' => $usces_entries['order']['discount'],
			'shipping_charge' => $usces_entries['order']['shipping_charge'],
			'cod_fee' => $usces_entries['order']['cod_fee'],
			'use_point' => $usedpoint
		);
		$tax = $usces->getTax( $total, $materials );
		$total += $tax;
		$payment = $usces->getPayments($usces_entries['order']['payment_name']);
		switch($payment['settlement']) {
		case 'acting_asj_card':
			if($total > WCEX_ASJ_PAYMENT_CARD_MAX || $total < WCEX_ASJ_PAYMENT_CARD_MIN) {
				$mes .= $payment['name'] . "は". WCEX_ASJ_PAYMENT_CARD_MIN . "円以上のお支払いでご利用いただけます。<br />";
			}
			break;
		case 'acting_asj_conv':
			if($total > WCEX_ASJ_PAYMENT_CONV_MAX || $total + $cod_fee < WCEX_ASJ_PAYMENT_CONV_MIN) {
				$mes .= $payment['name'] . "は". WCEX_ASJ_PAYMENT_CONV_MIN . "円以上のお支払いでご利用いただけます。<br />";
			}
			break;
		case 'acting_asj_atodene':
			if($total > WCEX_ASJ_PAYMENT_ATODENE_MAX || $total + $cod_fee < WCEX_ASJ_PAYMENT_ATODENE_MIN) {
				$mes .= $payment['name'] . "は". WCEX_ASJ_PAYMENT_ATODENE_MIN . "円以上のお支払いでご利用いただけます。<br />";
			}
			break;
		case 'acting_asj_atobarai':
			if($total > WCEX_ASJ_PAYMENT_ATODENE_MAX || $total + $cod_fee < WCEX_ASJ_PAYMENT_ATODENE_MIN) {
				$mes .= $payment['name'] . "は". WCEX_ASJ_PAYMENT_ATODENE_MIN . "円以上のお支払いでご利用いただけます。<br />";
			}
			break;
		}
		return $mes;
	}

	/**********************************************
	* 定期購入カートチェック
	* 通常商品・定期購入商品混在
	* 定期購入が１種類だけか
	***********************************************/
	public function asj_check_cart_regular_core($html, $mode) {
		global $wpdb;
		global $asj_payment_regular;

		$ret = false;
		if(!is_object($asj_payment_regular) || !defined("WCEX_ASJ_PAYMENT_REGULAR") || !WCEX_ASJ_PAYMENT_REGULAR::$opts['activate_flag']) {
			$ret = true;
		}
		if(!isset($_SESSION['usces_cart'])) {
			$ret = true;
		}
		if($mode === 1 || $mode === 0) {
			if($this->reg_chart_check === true) {
				$ret = true;
			}
		}
		if($ret === true) {
			if($mode === 1) {
				return $html;
			} else if($mode === 2) {
				return 0;
			} else {
				return;
			}
		}
		/* カート内の種類チェック */
		$normal_item_count = 0;
		$regular_item_count = 0;
		foreach($_SESSION['usces_cart'] as $key => $val) {
			$val = array_keys(unserialize($key));
			$post_id = $val[0];
			/* カスタムフィールド regular_kind の値をとる */
			/* これで定期購入かどうか区別する */
			$tbl_postmeta = $wpdb->prefix . "postmeta";
			$qstr = '';
			$qstr .= "SELECT T1.meta_value";
			$qstr .= " FROM $tbl_postmeta T1";
			$qstr .= " WHERE meta_key = 'regular_kind'";
			$qstr .= "  AND post_id = %d";
			$meta_value = $wpdb->get_var($wpdb->prepare($qstr, $post_id));
			if($meta_value && intval($meta_value) > 0) {
				$regular_item_count += 1;
			} else {
				$normal_item_count += 1;
			}
		}
		$tmp_msg = "";
		if($normal_item_count > 0 && $regular_item_count > 0) {
			$tmp_msg .= "通常商品、定期購入対応商品は同時購入できません。お手数ですが、個別に購入手続きをお願い致します。";
		}
		if($regular_item_count > 1) {
			if(strlen($tmp_msg)) {
				$tmp_msg .= "<br>\n";
			}
			$tmp_msg .= "定期購入商品は一商品ずつ購入してください。";
		}
		if(!usces_is_login() && $regular_item_count > 0) {
			if(strlen($tmp_msg)) {
				$tmp_msg .= "<br>\n";
			}
			$tmp_msg .= "定期購入商品はログインし、購入してください。";
		}
		if(strlen($tmp_msg)) {
			global $usces;
			if(isset($html)) {
				$html .= $tmp_msg;
			} else {
				if(strlen($usces->error_message)) {
					$usces->error_message .="<br>\n";
				}
				$usces->error_message .= $tmp_msg;
			}
		}
		$this->reg_chart_check = true;
		if($mode === 1) {
			return $html;
		} else if($mode === 2) {
			if(strlen($tmp_msg)) {
				return 1;
			} else {
				return 0;
			}
		} else {
			return;
		}
	}

	/**********************************************
	* 定期購入カートチェック
	* $this->purchase asjペイメントへ移動する前のチェック
	***********************************************/
	public function asj_check_cart_regular_purchase() {
		return $this->asj_check_cart_regular_core(NULL, 2);
	}

	/**********************************************
	* /wp-content/plugins/usc-e-shop/classes/usceshop.class.php
	* usces_after_main
	* 定期購入カートチェック
	* $usces->error_messageを追加するのみ
	***********************************************/
	public function asj_check_cart_regular() {
		if(usces_is_cart_page()) {
			$this->asj_check_cart_regular_core(NULL, 0);
		}
	}
	
	/**********************************************
	* /wp-content/plugins/usc-e-shop/classes/usceshop.class.php
	* usces_filter_cart_check
	* 定期購入カートチェック
	* カートで 次へ(customerinfo) を押したとき
	***********************************************/
	public function asj_filter_check_cart_regular($html) {
		return $this->asj_check_cart_regular_core($html, 1);
	}
}
